// ============================================================================
// This is a modified MenuSystem.cs to produce transparent menus. It's using 
// most of the same principles as the original MenuSystem.cs, but w/o the remoteCP
// function. My edits will be surrounded with the long equal (=) comment bars.
// 
// daerid
// 1/31/2001
// ============================================================================

// ============================================================================
// This is the height of Tribes' Text. You should really need to edit this
$MS::TextHeight = 18;
// This is how far from the left the menus will be 
// when using the CP/BP/TP options.
$MS::CenterPrintOffset = 40;
// ============================================================================


//Create a new menu
function MS::NewMenu(%menuName,%x,%y) {  
  //Create the new menu and be sure to overwrite any menu info that may be there.
	//This will allow you to rewrite menus on the fly if you wish to do so.
  %menuName = String::Replace(%menuName, " ", "_");
  DeleteVariables("$MS::"@%menuName@"*");
  $MS::[%menuName] = %menuName;
	// ============================================================================
  MS::SetLoc(%menuName,%x,%y);
  // ============================================================================
}


//Add a choice to a menu
function MS::AddChoice(%menuName, %key, %title, %function) {
	%menuName = String::Replace(%menuName, " ", "_");
	//If the actionMap doesnt exist, make it
	if(!$MS::[%menuname, actionMap]) { 
		NewActionMap(%MenuName@"Map.sae");
		$MS::[%menuname, actionMap] = "TRUE";
		bindCommand(keyboard0, make, "escape", TO, "MS::Do();");
	}
	//Edit the actionMap for the menu
	EditActionMap(%MenuName@"Map.sae");
	%tmp = $MS::[%menuName, Item]++;
	$MS::FunctionNum++;
	$MS::[%menuName, %tmp] = "<F2>"@%key@". <F1>"@%title;
	$MS::Function[$MS::FunctionNum] = %function;
	bindCommand(keyboard0, make, %key, TO, "MS::Do("@$MS::FunctionNum@");");
	bindCommand(keyboard0, break, %key, TO, "MS::Break();");
  // ============================================================================
  // For calculating the CP/BP/TP
  $MS::[%menuName,ht]+=$MS::TextHeight;
  // ============================================================================	
}

//Dummny break function.  This keeps from mixing up the keymaps.
function MS::Break() { }

function MS::AddMenu(%parentMenu, %key, %menuName) {
	//If the actionMap doesnt exist, make it
	%menuName = String::Replace(%menuName, " ", "_");
	%parentMenu = String::Replace(%parentMenu, " ", "_");
	if(!$MS::[%parentMenu, actionMap]) { 
		NewActionMap(%parentMenu@"Map.sae");
		$MS::[%parentMenu, actionMap] = "TRUE";
		bindCommand(keyboard0, make, "escape", TO, "MS::Do();");
	}
	//Edit the actionMap for the menu
	EditActionMap(%parentMenu@"Map.sae");
	%tmp = $MS::[%parentMenu, Item]++;
	$MS::[%parentMenu, %tmp] = "<F2>"@%key@". <F1>"@%menuName;
	bindCommand(keyboard0, make, %key, TO, "MS::Display("@%menuName@");");
	bindCommand(keyboard0, break, %key, TO, "MS::Break();");
  // ============================================================================
  // For calculating the CP/BP/TP
  $MS::[%parentMenu,ht]+=$MS::TextHeight;
  // We need to make sure that this child menu appears in the same location as 
  // the parent, if no values were specified on creation.
  %loc = $MS::[%parentMenu,loc];
  if (%loc == "")
    MS::SetLoc(%menuName,$MS::[%parentMenu,x],$MS::[%parentMenu,y]);
  else
    MS::SetLoc(%menuName,$MS::[%parentMenu,loc]);
  // ============================================================================
}

function MS::Display(%menuName) {
  if ($MenuObjCreated!="TRUE")
  {
    MS::Create();
  }
	%menuName = String::Replace(%menuName, " ", "_");
	if($MS::[%menuName] != "" && %menuName != $MS::CurrentMenu) {
		%text = "\t<JL><F0>"@String::UCase(%menuName)@"\n";
		for(%i = 1; %i <= $MS::[%menuName, Item]; %i++) {
			%text = %text@"\t\t"@$MS::[%menuName, %i]@"\n";
		}
		// ============================================================================
    %pos = MS::GetPos(%menuName);
    Control::SetPosition(MS::MenuObj,getWord(%pos,0),getWord(%pos,1));
    Control::SetValue(MS::MenuObj,%text);
    // ============================================================================
    
    //eval("remote"@$MS::[%menuName, Location]@"(2048, %text);");
		//remoteCP(2048, %text);
		//If a current menu map is up, we need to remove it
		PushActionMap(%MenuName@"Map.sae");
		if($MS::CurrentMenu != "") { PopActionMap($MS::CurrentMenu@"Map.sae"); }
		$MS::CurrentMenu = %menuName;
	}
	else {
		echo("Invalid menu call.  Menu does not exist.");
	}
}

function MS::Do(%functionNum) {
	// This is still needed as some functions depend on this to clear a centerprint
  remoteBP(2048, "");
  // ============================================================================
  // Clear the text
  Control::SetValue(MS::MenuObj,"");
  // ============================================================================
	PopActionMap($MS::CurrentMenu@"Map.sae");
	$MS::CurrentMenu = "";
	eval($MS::Function[%functionNum]);
}


// ============================================================================
// The Create function
function MS::Create()
{
  if (isObject($MENUOBJECT))
    MS::Clear(); 
  $MENUOBJECT = newObject(MS::MenuObj,FearGuiFormattedText,0,0,0,0);
  addToSet(PlayGui,$MENUOBJECT);
  $MenuObjCreated="TRUE";
}
//Event::Attach(eventPlayGuiCreated,MS::Create);

// The Clear Function
function MS::Clear()
{
  removeFromSet(PlayGui,$MENUOBJECT);
  if (isObject($MENUOBJECT))
    deleteObject($MENUOBJECT);
}
Event::Attach(eventExit,MS::Clear);

// Get the position function
function MS::GetPos(%menuName)
{
  %loc = $MS::[%menuName,loc];
  if (%loc == "")
    return $MS::[%menuName,x]@" "@$MS::[%menuName,y];
  else
  {
    %scrX = Stripped::getScreenSizeX();
    %scrY = Stripped::getScreenSizeY();
    if (%loc=="CP")
      %y = (%scrY/2)-($MS::[%menuName,ht]/2);
    else if (%loc=="BP")
      %y = (%scrY-20)-($MS::[%menuName,ht]);
    else if (%loc=="TP")
      %y = (%scrY+20);
    return $MS::CenterPrintOffset@" "@%y;
  }
}

// Set the location function
function MS::SetLoc(%menuName,%x,%y)
{
  // Basically, check to see if a CP,BP, or TP was passed as the second parameter
  // If so, then autocalculate based on menu height.
  //If no values supplied, then go "CP"
  if (%x=="" && %y=="")
    %x = "CP";
  // If num is passed to %x, set the x position
  if (IsNum(%x,"whole"))
    $MS::[%menuName,x] = %x;
  // If centerprint option passed, set accordingly
  else if (%x=="CP" || %x=="BP" || %x=="TP")
    $MS::[%menuName,loc] = %x;
  // if %y is numeric, set it accordingly
  if (IsNum(%y,"whole"))
    $MS::[%menuName,y] = %y;
}
// ============================================================================